;-------------------------------------------------------------------------------
;
; Title:            ds30 loader for 16-bit PIC/dsPIC
;
; File description: device constants for PIC24 and dsPIC
;
; Copyright:        Copyright 2011-2020 DigSol Sweden AB
;
;-------------------------------------------------------------------------------

;-------------------------------------------------------------------------------
;    This file is part of ds30 Loader.
;
;    ds30 Loader is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation.
;
;    ds30 Loader is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with ds30 Loader. If not, see <http://www.gnu.org/licenses/>.
;-------------------------------------------------------------------------------


;-------------------------------------------------------------------------------
; Includes
;-------------------------------------------------------------------------------
        .include    "devices_24F.inc"
        .include    "devices_24FJ.inc"
        .include    "devices_24HJ.inc"
        .include    "devices_30F.inc"
        .include    "devices_33FJ.inc"


;-------------------------------------------------------------------------------
; Family specific defines
;-------------------------------------------------------------------------------
        .ifdef IS_24F
            .equiv      FL_ER_CODE,         0x4058
            .equiv      FL_WR_CODE,         0x4004
            .equiv      EE_ER_CODE,         0x4058
            .equiv      EE_WR_CODE,         0x4004
        .endif

        .ifdef IS_24FJ
            .equiv      FL_ER_CODE,         0x4042
            .equiv      FL_WR_CODE,         0x4001
            .equiv      HAS_PAGES,          1
        .endif

        .ifdef IS_24HJ
            .equiv      FL_ER_CODE,         0x4042
            .equiv      FL_WR_CODE,         0x4001
            .equiv      CFG_ER_CODE,        0x4040
            .equiv      CFG_WR_CODE,        0x4000
            .equiv      CFG_TYPE2,          1
            .equiv      HAS_PAGES,          1
        .endif

        .ifdef IS_30F
            .equiv      FL_ER_CODE,         0x4041
            .equiv      FL_WR_CODE,         0x4001
            .equiv      EE_ER_CODE,         0x4044
            .equiv      EE_WR_CODE,         0x4004
            .equiv      CFG_WR_CODE,        0x4008
            .equiv      CFG_TYPE1,          1
        .endif

        .ifdef IS_33FJ
            .equiv      FL_ER_CODE,         0x4042
            .equiv      FL_WR_CODE,         0x4001
            .equiv      CFG_ER_CODE,        0x4040
            .equiv      CFG_WR_CODE,        0x4000
            .equiv      CFG_TYPE2,          1
            .equiv      HAS_PAGES,          1
        .endif

        .equiv          PAGESIZER,          (PAGESIZEW / ROWSIZEW)

        .ifndef VALID_DEV
            .error "Unknown device specified"
        .endif


;-------------------------------------------------------------------------------
; End of file
;-------------------------------------------------------------------------------
